-- We do not do very dependent types...

data Bool : Set where
  true	: Bool
  false : Bool

data List (A:Set) : Set where
  nil : List A
  (::) : A -> List A -> List A

infixr 10 ::

X : Set

if (A:Type) : Bool -> A -> A -> A
if true x y = x
if false x y = y

(==) : List X -> List X -> Bool
nil	== nil     = true
(x::xs) == (y::ys) = xs == ys
_       == _	   = false

Foo : (f : List X -> List X) -> Set
Foo f = if (f nil == nil) (List X) X

-- The following function would type-check if the first clause
-- could be used to type-check the second clause

f : List X -> List X
f  nil	  = nil
f (x::xs) = let ys : Foo f
		ys = xs
	    in ys

